<?php

// Read the index.csv and spit out a table in the chosen format
// set $format to bytitle or byauthor before including this file
if (!isset($format))
   $format = 'bytitle';

$lines = file("index.csv");

if ($format == 'bytitle')
   {
   $hlcol = 0;
   // sort the lines by title field as file contains data sorted by author
   foreach ($lines  as $value)
      {  // build an array with title as key
//      $bits = str_getcsv($value);  wait for upgrade to 5.3 or later
      $bits = preg_split('/\"/',$value);
//      echo "<pre>";
//      print_r($bits);
//      echo "</pre>";
//      exit;

//      [1] authors
//      [3] title
//      [5] filename
      
      $sort[$bits[3]] = '"' . $bits[3] . '","' . $bits[1] . '","' . $bits[5] . '"';      
//csv      $sort[$bits[1]] = '"' . $bits[1] . '","' . $bits[0] . '","' . $bits[2] . '"';
      if (count($bits) > 7)
         {
         $sort[$bits[3]] = $sort[$bits[3]] . ',"' . $bits[7] . '"';
//         $sort[$bits[1]] = $sort[$bits[1]] . ',"' . $bits[3];
//         echo count($bits) . '-' . $sort[$bits[3]] . "<br>\n";         
         }
//      echo count($bits) . ' ' . $sort[$bits[1]] . "<br>\n";         
      }
   ksort($sort);      
   $lines = $sort;
   }
else
   $hlcol = 1;

echo "<table border=1 cellspacing=0>\n";
if ($format == 'bytitle')
   echo "<tr style=\"background: lightgray;\"><th width=65% >Title	</th><th width=20%>Authors	</th><th width=25% >Downloadable File</th></tr>\n";
else
   echo "<tr style=\"background: lightgray;\"><th width=20%>Authors	</th><th width=65%>Title	</th><th width=25%>Downloadable File</th></tr>\n";

foreach ($lines as $key => $value)
   {
   echo " <tr>\n";
//   $bits = str_getcsv($value);
   $bits2 = preg_split('/"/',$value);
   unset($bits);
   $bits[0] = $bits2[1];
   $bits[1] = $bits2[3];
   $bits[2] = $bits2[5];
   if (array_key_exists(7,$bits2))
      $bits[3] = $bits2[7];
//echo "<pre>";      
//   print_r($bits);
//echo "</pre>";      
//   if (count($bits2) > 7)
//      exit;
   
   
   foreach ($bits as $ky => $val)
      {
      if (preg_match('/pdf/',$val) )
         echo "   <td bgcolor=#f0f0f0>";
      else
         echo "   <td>";
      if ((count($bits) > 3) && ($ky == 0))
         echo "<b style=\"color: magenta;\">WITHDRAWN</b><br>";
      if ($ky == $hlcol)  // hlcol cannot be 2
         echo "<b>$val</b>";
      else
         if ($ky == 2)  // 3rd field is the file link, check file exists as cross check as they get converted to PDF
            {
            if (!file_exists($val))
               echo "FILENOTFOUND $val";
            else
               echo "<a href=\"$val\">" . strtoupper($val) . "</a> <br>" . sprintf("%.1f",filesize($val)/1024) . " kbytes";
            }   
         else
            echo $val;

         
      echo "   </td>\n";
      if ($ky == 2) 
         break;
      }
   
   echo " </tr>\n";
   }   

echo "</table>\n";
?>